<script setup lang="ts">
import { computed, defineEmits, ref } from 'vue'
import GitlabHelperApi from '@/api/gitlabHelperApi'

// En un archivo de definiciones, por ejemplo, types.ts
export interface GitlabUserType {
  username: string
  name: string
  email: string
}

// Props definidas con sus tipos
const props = withDefaults(defineProps<{
  user: { id: number }
  gitlabUser: GitlabUserType
}>(), {
  user: () => ({ id: 0 }),
  gitlabUser: () => ({ username: '', name: '', email: '' }),
})

const emit = defineEmits<Emit>()

interface Emit {
  (e: 'created', value: number): void
}

const saving = ref(false)
const isRequest = ref(false)
const isError = ref(false)
const requestMessage = ref('')

// Computed properties para los estilos de alerta
const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')

// Método async para crear un token
const createToken = async () => {
  console.info('INFO: createToken')
  saving.value = true
  isRequest.value = false

  const gitlabHelper = new GitlabHelperApi()
  try {
    const response = await gitlabHelper.createUserAccessToken(props.user.id, props.gitlabUser.id, props.gitlabUser.username)

    console.debug('createToken response.data', response.data)
    requestMessage.value = response.data.message
    isError.value = false
    emit('created')
  }
  catch (error) {
    console.debug('error addGitLabUser', error.response.data)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}
</script>

<template>
  <VContainer>
    <VAlert
      class="mb-4"
      border="start"
      border-color="warning"
      variant="tonal"
    >
      <strong>Warning!</strong> The user already has a GitLab account, do you want to create a token for that user?
    </VAlert>

    <VAlert
      v-if="isRequest"
      border="left"
      :color="alertToggleVariant"
      class="mb-4"
      dense
      closable
    >
      <VIcon left>
        mdi-information
      </VIcon>
      <strong>{{ alertToggleText }}</strong> {{ requestMessage }}
    </VAlert>

    <VRow>
      <VCol cols="6">
        <VTextField
          v-model="props.gitlabUser.username"
          label="Username"
          readonly
        />
      </VCol>
      <VCol cols="6">
        <VTextField
          v-model="props.gitlabUser.name"
          label="Name"
          readonly
        />
      </VCol>
      <VCol cols="6">
        <VTextField
          v-model="props.gitlabUser.email"
          label="Email"
          readonly
        />
      </VCol>
    </VRow>
    <VRow>
      <VCol>
        <VBtn
          color="primary"
          :disabled="saving"
          @click="createToken"
        >
          <VProgressCircular
            v-if="saving"
            indeterminate
            size="20"
          />
          <span v-if="saving">Creating token...</span>
          <span v-else>Create a GitLab token</span>
        </VBtn>
      </VCol>
    </VRow>
  </VContainer>
</template>
